//
// Created by Antoine Bartuccio on 18/06/2018.
//

#ifndef LO41_PASSENGER_H
#define LO41_PASSENGER_H

#include "../Resident/Resident.h"
#include "../Visitor/Visitor.h"

typedef enum {RESIDENT, VISITOR} PASSENGER_TYPE;

typedef struct s_Passenger {
	PASSENGER_TYPE type;
	union {
		Resident * resident;
		Visitor * visitor;
	};
} Passenger;

#endif //LO41_PASSENGER_H
